#include <config.h>

#include <dune/grid/alugrid.hh>
#include <dune/grid/test/gridcheck.hh>
#include <dune/grid/test/checkintersectionit.hh>

#include <dune/subgrid/subgrid.hh>
#include <dune/subgrid/test/common.hh>

int main (int argc, char *argv[]) try
{
    typedef Dune::ALUSimplexGrid<2,2> Simplex2DGridType;
    typedef Dune::ALUCubeGrid<2,2>    Cube2DGridType;
//    typedef Dune::ALUSimplexGrid<3,3> Simplex3DGridType;
//    typedef Dune::ALUCubeGrid<3,3>    Cube3DGridType;

    size_t return_val = 0;

    return_val = std::max(return_val,checkWithHostGrid<Simplex2DGridType, SIMPLEX>());
    return_val = std::max(return_val,checkWithHostGrid<Cube2DGridType, CUBE>());
//    return_val = std::max(return_val,checkWithHostGrid<Simplex3DGridType, SIMPLEX>());
//    return_val = std::max(return_val,checkWithHostGrid<Cube3DGridType, CUBE>());

    std::cout << "Test for SubGrid with ALUGrid " << (return_val==0?"passed.":(return_val==1?"throws NotImplemented but otherwise passes.":"failed.")) << std::endl;
    return return_val;
}

// //////////////////////////////////
//   Error handler
// /////////////////////////////////
catch (Exception e) {
    std::cout << e << std::endl;
    return 1;
}
