#include <config.h>

#include <dune/grid/uggrid.hh>
#include <dune/grid/test/gridcheck.hh>
#include <dune/grid/test/checkintersectionit.hh>

#include <dune/subgrid/subgrid.hh>
#include <dune/subgrid/test/common.hh>

int main (int argc, char *argv[]) try
{
    typedef Dune::UGGrid<2> GridType2D;
    typedef Dune::UGGrid<3> GridType3D;

    size_t return_val = 0;

    return_val = std::max(return_val,checkWithHostGrid<GridType2D, SIMPLEX>());
//    return_val = std::max(return_val,checkWithHostGrid<GridType2D, CUBE>());
    return_val = std::max(return_val,checkWithHostGrid<GridType3D, SIMPLEX>());
 //   return_val = std::max(return_val,checkWithHostGrid<GridType3D, CUBE>());

    std::cout << "Test for SubGrid with UGGrid " << (return_val==0?"passed.":(return_val==1?"throws NotImplemented but otherwise passes.":"failed.")) << std::endl;
    return return_val;
}

// //////////////////////////////////
//   Error handler
// /////////////////////////////////
catch (Exception e) {
    std::cout << e << std::endl;
    return 1;
}
